// SI length units [m]
h = 0.100;
w = 0.050;
s = 0.0045;
l = 1.0;
r = s;

lc = 2*s;


Point(1) =  {0, -w/2,    -h/2,     lc};
Point(2) =  {0, -w/2,    -h/2+s,   lc};
Point(3) =  {0, -w/2,    +h/2-s,   lc};
Point(4) =  {0, -w/2,    +h/2,     lc};
                                   
Point(5) =  {0, +w/2,    -h/2,     lc};
Point(6) =  {0, +w/2,    -h/2+s,   lc};
Point(7) =  {0, +w/2,    +h/2-s,   lc};
Point(8) =  {0, +w/2,    +h/2,     lc};

Point(9)  = {0, -s/2-r, -h/2+s,    lc};
Point(10) = {0, -s/2-r, -h/2+s+r,  lc};
Point(11) = {0, -s/2-r, +h/2-s-r,  lc};
Point(12) = {0, -s/2-r, +h/2-s,    lc};
Point(13) = {0, -s/2,   -h/2+s+r,  lc};
Point(14) = {0, -s/2,   +h/2-s-r,  lc};
                                   
Point(15) = {0, +s/2+r, -h/2+s,    lc};
Point(16) = {0, +s/2+r, -h/2+s+r,  lc};
Point(17) = {0, +s/2+r, +h/2-s-r,  lc};
Point(18) = {0, +s/2+r, +h/2-s,    lc};
Point(19) = {0, +s/2,   -h/2+s+r,  lc};
Point(20) = {0, +s/2,   +h/2-s-r,  lc};

Line(1) = {1, 2};
Line(2) = {2, 9};
Circle(3) = {9, 10, 13};
Line(4) = {13, 14};
Circle(5) = {14, 11, 12};
Line(6) = {12, 3};
Line(7) = {3, 4};
Line(8) = {4, 8};
Line(9) = {8, 7};
Line(10) = {7, 18};
Circle(11) = {18, 17, 20};
Line(12) = {20, 19};
Circle(13) = {19, 16, 15};
Line(14) = {15, 6};
Line(15) = {6, 5};
Line(16) = {5, 1};

Line Loop(17) = {4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 1, 2, 3};
Plane Surface(18) = {17};

Extrude {l, 0, 0} {
  Surface{18};
}

Point(101) = {0.75*l, 0, +h/2, lc};
Point {101} In Surface {55};

Physical Surface("top") = {55};
Physical Surface("bottom") = {87};
Physical Surface("left") = {18};
Physical Surface("right") = {100};

Physical Surface("sides") = {59, 63, 67, 47, 43, 71, 75, 79, 83, 39, 99, 95, 91};
Physical Volume("bulk") = {1};

Physical Point("vertical_load") = {101};
Physical Line("free_top") = {24};
Physical Line("free_bottom") = {32};
